<?php

if ( !defined( 'TYPO3_MODE' ) )
{
  die( 'Access denied.' );
}

/* * ****************************************************************************
 * Set TYPO3 version
 * **************************************************************************** */

// #t0606, 160216, dwildt, +
list( $main, $sub, $bugfix ) = explode( '.', TYPO3_version );
$version = ( ( int ) $main ) * 1000000;
$version = $version + ( ( int ) $sub ) * 1000;
$version = $version + ( ( int ) $bugfix ) * 1;

/* * ****************************************************************************
 * Configuration by the extension manager
 * **************************************************************************** */

$confArr = unserialize( $GLOBALS[ 'TYPO3_CONF_VARS' ][ 'EXT' ][ 'extConf' ][ 'browser' ] );

/* * ****************************************************************************
 * Language for labels of static templates and page tsConfig
 * **************************************************************************** */

$llStatic = $confArr[ 'LLstatic' ];
switch ( $llStatic )
{
  case($llStatic == 'German'):
    $llStatic = 'de';
    break;
  default:
    $llStatic = 'default';
}

/* * ****************************************************************************
 * Methods for backend workflows
 * **************************************************************************** */

require_once(TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath( $_EXTKEY ) . 'pi1/class.tx_browser_pi1_backend.php');
require_once(TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath( $_EXTKEY ) . 'pi5/class.tx_browser_pi5_backend.php');

/* * ****************************************************************************
 * Enables the Include Static Templates
 * **************************************************************************** */

require_once( PATH_typo3conf . 'ext/browser/Configuration/ExtTables/includeStaticTemplates.php' );

/* * ****************************************************************************
 * Enables Page TSconfig for powermail
 * **************************************************************************** */

require_once( PATH_typo3conf . 'ext/browser/Configuration/ExtTables/TSconfig/Page/TxPowermail/default.php' );

/* * ****************************************************************************
 * Plugin general configuration
 * **************************************************************************** */

// #i0301, 170124, dwildt, 4-
//// #t0606, 160216, dwildt, +
//if ( $version < 7000000 )
//{
//  \TYPO3\CMS\Core\Utility\GeneralUtility::loadTCA( 'tt_content' );
//}

/* * ****************************************************************************
 * Wizard Icons
 * **************************************************************************** */

if ( TYPO3_MODE == 'BE' )
{
  $TBE_MODULES_EXT[ 'xMOD_db_new_content_el' ][ 'addElClasses' ][ 'tx_browser_pi1_backend_wizicon' ] = TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath( $_EXTKEY ) . 'pi1/class.tx_browser_pi1_backend_wizicon.php';
  $TBE_MODULES_EXT[ 'xMOD_db_new_content_el' ][ 'addElClasses' ][ 'tx_browser_pi5_backend_wizicon' ] = TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath( $_EXTKEY ) . 'pi5/class.tx_browser_pi5_backend_wizicon.php';
  $TBE_MODULES_EXT[ 'xMOD_db_new_content_el' ][ 'addElClasses' ][ 'tx_browser_pi4_backend_wizicon' ] = TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath( $_EXTKEY ) . 'pi4/class.tx_browser_pi4_backend_wizicon.php';
  $TBE_MODULES_EXT[ 'xMOD_db_new_content_el' ][ 'addElClasses' ][ 'tx_browser_pi3_backend_wizicon' ] = TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath( $_EXTKEY ) . 'pi3/class.tx_browser_pi3_backend_wizicon.php';
}

/* * ****************************************************************************
 * pagetree icon
 * **************************************************************************** */

$TCA[ 'pages' ][ 'columns' ][ 'module' ][ 'config' ][ 'items' ][] = array( 'Browser', 'browser', TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath( $_EXTKEY ) . 'ext_icon.svg' );
TYPO3\CMS\Backend\Sprite\SpriteManager::addTcaTypeIcon( 'pages', 'contains-browser', '../typo3conf/ext/browser/ext_icon.svg' );

/* * ****************************************************************************
 * Plugin 1 configuration: Browser
 * **************************************************************************** */

TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
        $_EXTKEY
        , 'Pi1'
        , 'LLL:EXT:browser/locallang_db.xml:tt_content.list_type_pi1'
        , TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath( $_EXTKEY ) . 'ext_icon.svg'
);
$pluginSignature = str_replace( '_', '', $_EXTKEY ) . '_pi1';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_excludelist' ][ $pluginSignature ] = 'layout,select_key';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_addlist' ][ $pluginSignature ] = 'pi_flexform';
TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue(
        $pluginSignature, 'FILE:EXT:' . $_EXTKEY . '/Configuration/FlexForms/pi1/flexform.xml'
);
TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPlugin(
        array(
  'LLL:EXT:browser/locallang_db.xml:tt_content.list_type_pi1'
  , $pluginSignature
  , 'EXT:browser/ext_icon.svg'
        )
        , 'list_type'
);


/* * ****************************************************************************
 * Plugin 6 configuration: Frontend Editing
 * **************************************************************************** */

TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
        $_EXTKEY
        , 'Pi6'
        , 'LLL:EXT:browser/locallang_db.xml:tt_content.list_type_pi6'
        , TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath( $_EXTKEY ) . 'ext_icon.svg'
);
$pluginSignature = str_replace( '_', '', $_EXTKEY ) . '_pi6';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_excludelist' ][ $pluginSignature ] = 'layout,select_key,pages,recursive';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_addlist' ][ $pluginSignature ] = 'pi_flexform';
TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue(
        $pluginSignature, 'FILE:EXT:' . $_EXTKEY . '/Configuration/FlexForms/pi6/flexform.xml'
);
TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPlugin(
        array(
  'LLL:EXT:browser/locallang_db.xml:tt_content.list_type_pi6'
  , $pluginSignature
  , 'EXT:browser/ext_icon.svg'
        )
        , 'list_type'
);

/* * ****************************************************************************
 * Plugin 5 configuration
 * **************************************************************************** */

TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
        $_EXTKEY
        , 'Pi5'
        , 'LLL:EXT:browser/locallang_db.xml:tt_content.list_type_pi5'
        , TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath( $_EXTKEY ) . 'ext_icon.svg'
);
$pluginSignature = str_replace( '_', '', $_EXTKEY ) . '_pi5';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_excludelist' ][ $pluginSignature ] = 'layout,select_key';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_addlist' ][ $pluginSignature ] = 'pi_flexform';
TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue(
        $pluginSignature, 'FILE:EXT:' . $_EXTKEY . '/Configuration/FlexForms/pi5/flexform.xml'
);
// Register our file with the flexform structure
TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPlugin( array(
  'LLL:EXT:browser/locallang_db.xml:tt_content.list_type_pi5'
  , $pluginSignature
  , 'EXT:browser/ext_icon.svg'
        )
        , 'list_type'
);
// Add the Flexform to the Plugin List
// Plugin 1 configuration

/* * ****************************************************************************
 * Plugin 4 configuration
 * **************************************************************************** */

TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
        $_EXTKEY
        , 'Pi4'
        , 'LLL:EXT:browser/locallang_db.xml:tt_content.list_type_pi4'
        , TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath( $_EXTKEY ) . 'ext_icon.svg'
);
$pluginSignature = str_replace( '_', '', $_EXTKEY ) . '_pi4';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_excludelist' ][ $pluginSignature ] = 'layout,select_key';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_addlist' ][ $pluginSignature ] = 'pi_flexform';
TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue(
        $pluginSignature, 'FILE:EXT:' . $_EXTKEY . '/Configuration/FlexForms/pi4/flexform.xml'
);
// Register our file with the flexform structure
TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPlugin( array(
  'LLL:EXT:browser/locallang_db.xml:tt_content.list_type_pi4'
  , $pluginSignature
  , 'EXT:browser/ext_icon.svg'
        )
        , 'list_type'
);
// Add the Flexform to the Plugin List

/* * ****************************************************************************
 * Plugin 3 configuration: Manuals
 * **************************************************************************** */

TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
        $_EXTKEY
        , 'Pi3'
        , 'LLL:EXT:browser/locallang_db.xml:tt_content.list_type_pi3'
        , TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath( $_EXTKEY ) . 'ext_icon.svg'
);
$pluginSignature = str_replace( '_', '', $_EXTKEY ) . '_pi3';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_excludelist' ][ $pluginSignature ] = 'layout,select_key,pages,recursive';
$TCA[ 'tt_content' ][ 'types' ][ 'list' ][ 'subtypes_addlist' ][ $pluginSignature ] = 'pi_flexform';
TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue(
        $pluginSignature, 'FILE:EXT:' . $_EXTKEY . '/Configuration/FlexForms/pi3/flexform.xml'
);
// Register our file with the flexform structure
TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPlugin( array(
  'LLL:EXT:browser/locallang_db.xml:tt_content.list_type_pi3'
  , $pluginSignature
  , 'EXT:browser/ext_icon.svg'
        )
        , 'list_type'
);
// Add the Flexform to the Plugin List